diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/model/position-allocator.h ns-3.31/src/mobility/model/position-allocator.h
--- ns-3.30.1/src/mobility/model/position-allocator.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mobility/model/position-allocator.h	2020-06-27 17:38:30.000000000 -0700
@@ -279,8 +279,16 @@
 
 /**
  * \ingroup mobility
- * \brief Allocate random positions within a disc according to a given distribution for the polar coordinates of each node 
-          with respect to the provided center of the disc 
+ * \brief Allocate random positions within a disc according to
+ * a given distribution for the polar coordinates of each node 
+ * with respect to the provided center of the disc.
+ *
+ * \note With the default uniform distribution over \f$2 \pi\f$ in \c theta and a
+ * uniform distribution for \c rho this position allocator will *not*
+ * uniformly populate the disc.  The radial distribution will be proportional
+ * to \f$\frac{1}{r^2}\f$.
+ *
+ * To get a uniform distribution over a circle use the UniformDiscPositionAllocator.
  */
 class RandomDiscPositionAllocator : public PositionAllocator
 {
@@ -294,13 +302,13 @@
   virtual ~RandomDiscPositionAllocator ();
 
   /**
-   * \brief Set the random variable that generates position radius
-   * \param theta random variable that represents the radius of a position in a random disc.
+   * \brief Set the random variable that generates position angle, in radians.
+   * \param theta Random variable that represents the angle in radians of a position in a random disc.
    */
   void SetTheta (Ptr<RandomVariableStream> theta);
   /**
-   * \brief Set the random variable that generates position angle
-   * \param rho random variable that represents the angle (gradients) of a position in a random disc.
+   * \brief Set the random variable that generates position radius, in meters
+   * \param rho Random variable that represents the radius of a position, in meters, in a random disc.
    */
   void SetRho (Ptr<RandomVariableStream> rho);
   /** 
@@ -329,7 +337,7 @@
 
 /**
  * \ingroup mobility
- * \brief Allocate the positions uniformely (with constant density) randomly within a disc.
+ * \brief Allocate the positions uniformly (with constant density) randomly within a disc.
  *
  * UniformDiscPositionAllocator allocates the positions randomly within a disc \f$ D \f$ lying on the
  * plane \f$ z\f$ and having center at coordinates \f$ (x,y,z) \f$
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/model/random-direction-2d-mobility-model.cc ns-3.31/src/mobility/model/random-direction-2d-mobility-model.cc
--- ns-3.30.1/src/mobility/model/random-direction-2d-mobility-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mobility/model/random-direction-2d-mobility-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -144,7 +144,6 @@
 RandomDirection2dMobilityModel::DoSetPosition (const Vector &position)
 {
   m_helper.SetPosition (position);
-  Simulator::Remove (m_event);
   m_event.Cancel ();
   m_event = Simulator::ScheduleNow (&RandomDirection2dMobilityModel::DoInitializePrivate, this);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/model/random-walk-2d-mobility-model.cc ns-3.31/src/mobility/model/random-walk-2d-mobility-model.cc
--- ns-3.30.1/src/mobility/model/random-walk-2d-mobility-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mobility/model/random-walk-2d-mobility-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -167,7 +167,7 @@
 {
   NS_ASSERT (m_bounds.IsInside (position));
   m_helper.SetPosition (position);
-  Simulator::Remove (m_event);
+  m_event.Cancel ();
   m_event = Simulator::ScheduleNow (&RandomWalk2dMobilityModel::DoInitializePrivate, this);
 }
 Vector
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/model/random-waypoint-mobility-model.cc ns-3.31/src/mobility/model/random-waypoint-mobility-model.cc
--- ns-3.30.1/src/mobility/model/random-waypoint-mobility-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mobility/model/random-waypoint-mobility-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -104,7 +104,7 @@
 RandomWaypointMobilityModel::DoSetPosition (const Vector &position)
 {
   m_helper.SetPosition (position);
-  Simulator::Remove (m_event);
+  m_event.Cancel ();
   m_event = Simulator::ScheduleNow (&RandomWaypointMobilityModel::DoInitializePrivate, this);
 }
 Vector
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/model/steady-state-random-waypoint-mobility-model.cc ns-3.31/src/mobility/model/steady-state-random-waypoint-mobility-model.cc
--- ns-3.30.1/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -273,7 +273,7 @@
   if (alreadyStarted)
     {
       m_helper.SetPosition (position);
-      Simulator::Remove (m_event);
+      m_event.Cancel ();
       m_event = Simulator::ScheduleNow (&SteadyStateRandomWaypointMobilityModel::Start, this);
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/test/box-line-intersection-test.cc ns-3.31/src/mobility/test/box-line-intersection-test.cc
--- ns-3.30.1/src/mobility/test/box-line-intersection-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/mobility/test/box-line-intersection-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,147 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include "box-line-intersection-test.h"
+#include <ns3/simulator.h>
+
+using namespace ns3;
+
+/**
+ * This TestSuite tests the intersection of a line segment
+ * between two 3D positions with a 3D box. It generates two
+ * positions from a set of predefined positions (see GeneratePosition method),
+ * and then tests the intersection of a line segments between them with a box
+ * of predefined dimensions.
+ */
+
+
+BoxLineIntersectionTestSuite::BoxLineIntersectionTestSuite ()
+  : TestSuite ("box-line-intersection", UNIT)
+{
+  // Box in the positive x-plane to check the intersection with.
+  Box box = Box (890.0, 990.0, 840.0, 870.0, 0.0, 6.0);
+  bool intersect;
+  // Test #1 :
+  // pos1 (index 3) is outside the box and below the height of the box.
+  // pos2 (index 6) is outside the box and above the height of the box.
+  // Expected result: No intersection. The box is between the two position,
+  // however, pos2 is above the height of the box.
+  intersect = false;
+  AddTestCase (new BoxLineIntersectionTestCase (3, 6, box, intersect), TestCase::QUICK);
+
+  // Test #2 :
+  // pos1 (index 1) is inside the box.
+  // pos2 (index 2) is inside the box.
+  // Expected result: Intersection.
+  intersect = true;
+  AddTestCase (new BoxLineIntersectionTestCase (1, 2, box, intersect), TestCase::QUICK);
+
+  // Test #3 :
+  // pos1 (index 3) is outside the box.
+  // pos2 (index 1) is inside the box.
+  // Expected result: Intersection.
+  intersect = true;
+  AddTestCase (new BoxLineIntersectionTestCase (3, 1, box, intersect), TestCase::QUICK);
+
+  // Test #4:
+  // pos1 (index 4) is outside the box.
+  // pos2 (index 5) is outside the box.
+  // Expected result: Intersection because box is in between the two positions.
+  intersect = true;
+  AddTestCase (new BoxLineIntersectionTestCase (4, 5, box, intersect), TestCase::QUICK);
+}
+
+static BoxLineIntersectionTestSuite boxLineIntersectionTestSuite; //!< boxLineIntersectionTestSuite
+
+
+/**
+ * TestCase
+ */
+
+BoxLineIntersectionTestCase::BoxLineIntersectionTestCase (uint16_t indexPos1, uint16_t indexPos2, Box box, bool intersect)
+  : TestCase (BuildNameString (indexPos1, indexPos2, box, intersect)),
+  m_indexPos1 (indexPos1),
+  m_indexPos2 (indexPos2),
+  m_box (box),
+  m_intersect (intersect)
+{
+}
+
+BoxLineIntersectionTestCase::~BoxLineIntersectionTestCase ()
+{
+}
+
+std::string
+BoxLineIntersectionTestCase::BuildNameString (uint16_t indexPos1, uint16_t indexPos2, Box box, bool intersect)
+{
+  std::ostringstream oss;
+  oss << "Box line intersection test : checking"
+      << " pos1 index " << indexPos1 << " and pos2 index " << indexPos2
+      << " intersection with the box (" << box.xMin << ", " << box.xMax
+      << ", " << box.yMin << ", " << box.yMax
+      << ", " << box.zMin << ", " << box.zMax
+      << "). The expected intersection flag = " << intersect << "  ";
+  return oss.str ();
+}
+
+void
+BoxLineIntersectionTestCase::DoRun (void)
+{
+
+  Vector pos1 = CreatePosition (m_indexPos1, (m_box.zMax - m_box.zMin));
+  Vector pos2 = CreatePosition (m_indexPos2, (m_box.zMax - m_box.zMin));
+
+  bool intersect = m_box.IsIntersect (pos1, pos2);
+
+  NS_TEST_ASSERT_MSG_EQ (intersect, m_intersect, "Unexpected result of box and line segment intersection!");
+  Simulator::Destroy ();
+}
+
+Vector
+BoxLineIntersectionTestCase::CreatePosition (uint16_t index, double boxHeight)
+{
+  Vector pos;
+
+  switch (index)
+    {
+    case 1:
+      pos = Vector (934.0, 852.0, 1.5);
+      break;
+    case 2:
+      pos = Vector (931.0,861.0, 1.5);
+      break;
+    case 3:
+      pos = Vector (484.0, 298.0, 1.5);
+      break;
+    case 4:
+      pos = Vector (1000.0, 850.0, 1.5);
+      break;
+    case 5:
+      pos = Vector (850.0, 850.0, 1.5);
+      break;
+    case 6:
+      pos = Vector (934.0, 852.0, boxHeight + 14.0);
+      break;
+    default:
+      NS_FATAL_ERROR ("Unknown position index");
+      break;
+    }
+
+  return pos;
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/test/box-line-intersection-test.h ns-3.31/src/mobility/test/box-line-intersection-test.h
--- ns-3.30.1/src/mobility/test/box-line-intersection-test.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/mobility/test/box-line-intersection-test.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,101 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#ifndef BOX_LINE_INTERSECTION_TEST_H
+#define BOX_LINE_INTERSECTION_TEST_H
+
+#include <ns3/test.h>
+#include <ns3/vector.h>
+#include <ns3/box.h>
+
+
+using namespace ns3;
+
+/**
+ * \brief Test suite for
+ *
+ * \sa ns3::BoxLineIntersectionTestSuite
+ */
+class BoxLineIntersectionTestSuite : public TestSuite
+{
+public:
+  /**
+   * Constructor
+   */
+  BoxLineIntersectionTestSuite ();
+};
+
+/**
+ * \brief TestCase to check the box line intersection
+ */
+class BoxLineIntersectionTestCase : public TestCase
+{
+public:
+  /**
+   * \brief Create BoxLineIntersectionTestCase
+   * \param indexPos1 Index of the first position to generate
+   * \param indexPos2 Index of the second position to generate
+   * \param box The 3D box
+   * \param intersect The expected result of the test. True for intersection,
+   *        false otherwise
+   */
+  BoxLineIntersectionTestCase (uint16_t indexPos1, uint16_t indexPos2, Box box, bool intersect);
+  /**
+   * \brief Builds the test name string based on provided parameter values
+   * \param indexPos1 Index of the first position to generate
+   * \param indexPos2 Index of the second position to generate
+   * \param box The 3D box
+   * \param intersect The expected result of the test. True for intersection,
+   *        false otherwise
+   *
+   * \return The name string
+   */
+  std::string BuildNameString (uint16_t indexPos1, uint16_t indexPos2, Box box, bool intersect);
+  /**
+   * Destructor
+   */
+  virtual ~BoxLineIntersectionTestCase ();
+
+private:
+  /**
+   * \brief Setup the simulation according to the configuration set by the
+   *        class constructor, run it, and verify the result.
+   */
+  virtual void DoRun (void);
+  /**
+   * \brief Create the position as per the given index
+   *
+   * \param index The index of the position to be created
+   * \param boxHeight The height if the box. It is used to place the position
+   *        above the height of the box
+   * \returns The ns-3 3D Vector specifying the position
+   */
+  Vector CreatePosition (uint16_t index, double boxHeight);
+
+  uint16_t m_indexPos1 {0}; //!< First position index
+  uint16_t m_indexPos2 {0}; //!< Second position index
+  Box m_box; //!< The box to check the intersection with
+  bool m_intersect {false}; /**< Flag to indicate the intersection.
+                             * True, for intersection, false otherwise.
+                             */
+
+};
+
+
+#endif /* BOX_LINE_INTERSECTION_TEST_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mobility/wscript ns-3.31/src/mobility/wscript
--- ns-3.30.1/src/mobility/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mobility/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -33,8 +33,15 @@
         'test/waypoint-mobility-model-test.cc',
         'test/geo-to-cartesian-test.cc',
         'test/rand-cart-around-geo-test.cc',
+        'test/box-line-intersection-test.cc',
         ]
 
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        mobility_test.source.extend([
+        #   'test/mobility-examples-test-suite.cc',
+            ])
+    
     headers = bld(features='ns3header')
     headers.module = 'mobility'
     headers.source = [
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/bindings/modulegen__gcc_ILP32.py ns-3.31/src/mpi/bindings/modulegen__gcc_ILP32.py
--- ns-3.30.1/src/mpi/bindings/modulegen__gcc_ILP32.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/mpi/bindings/modulegen__gcc_ILP32.py	2020-06-27 17:38:30.000000000 -0700
@@ -1082,7 +1082,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv4Address const &', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsLocalMulticast() const [member function]
     cls.add_method('IsLocalMulticast', 
                    'bool', 
@@ -1174,7 +1174,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv4Mask', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1206,10 +1206,11 @@
     cls.add_constructor([param('ns3::Ipv6Address const &', 'addr')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address::Ipv6Address(ns3::Ipv6Address const * addr) [constructor]
     cls.add_constructor([param('ns3::Ipv6Address const *', 'addr')])
-    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Address::CombinePrefix(ns3::Ipv6Prefix const & prefix) [member function]
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Address::CombinePrefix(ns3::Ipv6Prefix const & prefix) const [member function]
     cls.add_method('CombinePrefix', 
                    'ns3::Ipv6Address', 
-                   [param('ns3::Ipv6Prefix const &', 'prefix')])
+                   [param('ns3::Ipv6Prefix const &', 'prefix')], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::ConvertFrom(ns3::Address const & address) [member function]
     cls.add_method('ConvertFrom', 
                    'ns3::Ipv6Address', 
@@ -1265,6 +1266,11 @@
                    'ns3::Ipv6Address', 
                    [], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::HasPrefix(ns3::Ipv6Prefix const & prefix) const [member function]
+    cls.add_method('HasPrefix', 
+                   'bool', 
+                   [param('ns3::Ipv6Prefix const &', 'prefix')], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsAllHostsMulticast() const [member function]
     cls.add_method('IsAllHostsMulticast', 
                    'bool', 
@@ -1294,7 +1300,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv6Address const &', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsIpv4MappedAddress() const [member function]
     cls.add_method('IsIpv4MappedAddress', 
                    'bool', 
@@ -1330,6 +1336,11 @@
                    'bool', 
                    [], 
                    is_const=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Address prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1350,6 +1361,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Mac8Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Address mac) [member function]
+    cls.add_method('MakeAutoconfiguredLinkLocalAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'mac')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Mac16Address mac) [member function]
     cls.add_method('MakeAutoconfiguredLinkLocalAddress', 
                    'ns3::Ipv6Address', 
@@ -1410,6 +1426,10 @@
     cls.add_constructor([param('uint8_t *', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(char const * prefix) [constructor]
     cls.add_constructor([param('char const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(uint8_t * prefix, uint8_t prefixLength) [constructor]
+    cls.add_constructor([param('uint8_t *', 'prefix'), param('uint8_t', 'prefixLength')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(char const * prefix, uint8_t prefixLength) [constructor]
+    cls.add_constructor([param('char const *', 'prefix'), param('uint8_t', 'prefixLength')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(uint8_t prefix) [constructor]
     cls.add_constructor([param('uint8_t', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const & prefix) [constructor]
@@ -1426,6 +1446,11 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): uint8_t ns3::Ipv6Prefix::GetMinimumPrefixLength() const [member function]
+    cls.add_method('GetMinimumPrefixLength', 
+                   'uint8_t', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Prefix ns3::Ipv6Prefix::GetOnes() [member function]
     cls.add_method('GetOnes', 
                    'ns3::Ipv6Prefix', 
@@ -1445,7 +1470,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv6Prefix const &', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1456,6 +1481,10 @@
                    'void', 
                    [param('std::ostream &', 'os')], 
                    is_const=True)
+    ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::SetPrefixLength(uint8_t prefixLength) [member function]
+    cls.add_method('SetPrefixLength', 
+                   'void', 
+                   [param('uint8_t', 'prefixLength')])
     return
 
 def register_Ns3Mac48Address_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/bindings/modulegen__gcc_LP64.py ns-3.31/src/mpi/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/mpi/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/mpi/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -1082,7 +1082,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv4Address const &', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsLocalMulticast() const [member function]
     cls.add_method('IsLocalMulticast', 
                    'bool', 
@@ -1174,7 +1174,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv4Mask', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1206,10 +1206,11 @@
     cls.add_constructor([param('ns3::Ipv6Address const &', 'addr')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address::Ipv6Address(ns3::Ipv6Address const * addr) [constructor]
     cls.add_constructor([param('ns3::Ipv6Address const *', 'addr')])
-    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Address::CombinePrefix(ns3::Ipv6Prefix const & prefix) [member function]
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Address::CombinePrefix(ns3::Ipv6Prefix const & prefix) const [member function]
     cls.add_method('CombinePrefix', 
                    'ns3::Ipv6Address', 
-                   [param('ns3::Ipv6Prefix const &', 'prefix')])
+                   [param('ns3::Ipv6Prefix const &', 'prefix')], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::ConvertFrom(ns3::Address const & address) [member function]
     cls.add_method('ConvertFrom', 
                    'ns3::Ipv6Address', 
@@ -1265,6 +1266,11 @@
                    'ns3::Ipv6Address', 
                    [], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::HasPrefix(ns3::Ipv6Prefix const & prefix) const [member function]
+    cls.add_method('HasPrefix', 
+                   'bool', 
+                   [param('ns3::Ipv6Prefix const &', 'prefix')], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsAllHostsMulticast() const [member function]
     cls.add_method('IsAllHostsMulticast', 
                    'bool', 
@@ -1294,7 +1300,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv6Address const &', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsIpv4MappedAddress() const [member function]
     cls.add_method('IsIpv4MappedAddress', 
                    'bool', 
@@ -1330,6 +1336,11 @@
                    'bool', 
                    [], 
                    is_const=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Address prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1350,6 +1361,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Mac8Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Address mac) [member function]
+    cls.add_method('MakeAutoconfiguredLinkLocalAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'mac')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Mac16Address mac) [member function]
     cls.add_method('MakeAutoconfiguredLinkLocalAddress', 
                    'ns3::Ipv6Address', 
@@ -1410,6 +1426,10 @@
     cls.add_constructor([param('uint8_t *', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(char const * prefix) [constructor]
     cls.add_constructor([param('char const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(uint8_t * prefix, uint8_t prefixLength) [constructor]
+    cls.add_constructor([param('uint8_t *', 'prefix'), param('uint8_t', 'prefixLength')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(char const * prefix, uint8_t prefixLength) [constructor]
+    cls.add_constructor([param('char const *', 'prefix'), param('uint8_t', 'prefixLength')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(uint8_t prefix) [constructor]
     cls.add_constructor([param('uint8_t', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const & prefix) [constructor]
@@ -1426,6 +1446,11 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): uint8_t ns3::Ipv6Prefix::GetMinimumPrefixLength() const [member function]
+    cls.add_method('GetMinimumPrefixLength', 
+                   'uint8_t', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Prefix ns3::Ipv6Prefix::GetOnes() [member function]
     cls.add_method('GetOnes', 
                    'ns3::Ipv6Prefix', 
@@ -1445,7 +1470,7 @@
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ipv6Prefix const &', 'other')], 
-                   is_const=True)
+                   is_const=True, deprecated=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1456,6 +1481,10 @@
                    'void', 
                    [param('std::ostream &', 'os')], 
                    is_const=True)
+    ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::SetPrefixLength(uint8_t prefixLength) [member function]
+    cls.add_method('SetPrefixLength', 
+                   'void', 
+                   [param('uint8_t', 'prefixLength')])
     return
 
 def register_Ns3Mac48Address_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/examples/nms-p2p-nix-distributed.cc ns-3.31/src/mpi/examples/nms-p2p-nix-distributed.cc
--- ns-3.30.1/src/mpi/examples/nms-p2p-nix-distributed.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/examples/nms-p2p-nix-distributed.cc	2020-06-27 17:38:30.000000000 -0700
@@ -60,8 +60,6 @@
 int
 main (int argc, char *argv[])
 {
-#ifdef NS3_MPI
-
   typedef std::vector<NodeContainer> vectorOfNodeContainer;
   typedef std::vector<vectorOfNodeContainer> vectorOfVectorOfNodeContainer;
   typedef std::vector<vectorOfVectorOfNodeContainer> vectorOfVectorOfVectorOfNodeContainer;  
@@ -91,7 +89,7 @@
   int nBytes = 500000; // Bytes for each on/off app
   bool nix = true;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("CN", "Number of total CNs [2]", nCN);
   cmd.AddValue ("LAN", "Number of nodes per LAN [42]", nLANClients);
   cmd.AddValue ("single", "1 if use single flow", single);
@@ -624,8 +622,5 @@
   std::cout << "Simulator run time: " << d2 << std::endl;
   std::cout << "Total elapsed time: " << d1 + d2 << std::endl;
   return 0;
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/examples/simple-distributed.cc ns-3.31/src/mpi/examples/simple-distributed.cc
--- ns-3.30.1/src/mpi/examples/simple-distributed.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/examples/simple-distributed.cc	2020-06-27 17:38:30.000000000 -0700
@@ -51,10 +51,7 @@
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
-
-#ifdef NS3_MPI
 #include <mpi.h>
-#endif
 
 using namespace ns3;
 
@@ -63,14 +60,12 @@
 int
 main (int argc, char *argv[])
 {
-#ifdef NS3_MPI
-
   bool nix = true;
   bool nullmsg = false;
   bool tracing = false;
 
   // Parse command line
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("nix", "Enable the use of nix-vector or global routing", nix);
   cmd.AddValue ("nullmsg", "Enable the use of null-message synchronization", nullmsg);
   cmd.AddValue ("tracing", "Enable pcap tracing", tracing);
@@ -271,7 +266,4 @@
   // Exit the MPI execution environment
   MpiInterface::Disable ();
   return 0;
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
